	IFND LIBRARIES_PATCH_TAGS_I
LIBRARIES_PATCH_TAGS_I SET 1
**
**	Filename:	libraries/patchtags.i
**	Release:	3.0
**	Date:		04.05.94
**
**	(C) Copyright 1993/94 Stefan Fuchs
**	All rights reserved
**
**      definition of patch.library tags


	IFND UTILITY_TAGITEM_I
	INCLUDE "utility/tagitem.i"
	ENDC

;-------------------------------------------------------------------------
;I: InstalPatchTags()
;R: RemovePatchTags()
;F: FindPatchTags()
;S: SetPatch()
;G: GetPatch()

	ENUM TAG_USER+$5000

	EITEM PATT_LibraryName		;(STRPTR) (I)
					;Pointer to a library name
	EITEM PATT_DeviceName		;(STRPTR) (I)
					;Pointer to a device name
	EITEM PATT_LibraryBase		;(struct Library *) (I)
					;Pointer to a library, device or resource base
					;structure

	EITEM PATT_LibVersion		;(ULONG) (I) Default: NULL (any version)
					;Versionnumber for exec.library/OpenLibrary
	EITEM PATT_Reserved01		;as it says
	EITEM PATT_DevFlags		;(ULONG) (I) Default: NULL
					;Flags for exec.library/OpenDevice()
	EITEM PATT_DevUnit		;(ULONG) (I) Default: NULL
					;Unit for exec.library/OpenDevice()

	EITEM PATT_PatchName		;(STRPTR) (IF) Default: No ID-String
					;pointer to an IDString for the patch
					;(BOOL) (G) Default: False
					;Return the name of the patch
	EITEM PATT_Priority		;(BYTE) (I) Default: NULL
					;priority (-127...+126) of the patch
					;Positive priorities indicate that the patchcode will be run before the Original
					;Negative priorities indicate that the patchcode will be run after the Original
					;the priority NULL (default) indicates that the patchcode will be run instead of the Original
	EITEM PATT_NewCodeSize		;(ULONG) (I) Default: NULL
					;size of code in bytes starting at funcEntry
	EITEM PATT_Result2		;(APTR) (IG)
					;pointer to longword for errorcodes
					;(see patch.h)

	EITEM PATT_CreateTaskList	;(ULONG) (IS) (V3)
					;Creates a TaskList of the given type 
					;(TL_TYPE_INCLUDE / TL_TYPE_EXCLUDE) 
					;(see patch.h)
	EITEM PATT_DeleteTaskList	;(BOOL) (IS) (V3) Default: False
					;Deletes any exisiting TaskList
					;This will be done implicitly, when a patch is removed
	EITEM PATT_AddTaskID		;(struct Task *) (IS) (V3)
					;Adds a task address to the patch TaskList
					;this tag may also be used in conjunction with SetPatchA()
	EITEM PATT_AddTaskName		;(STRPTR) (IS) (V3)
					;Adds a task of the given name to address to the
					;patch TaskList
	EITEM PATT_Reserved02		;as it says
	EITEM PATT_RemTaskID		;(struct Task *) (IS) (V3)
					;Removes a task address from the patch TaskList
	EITEM PATT_RemTaskName		;(STRPTR) (IS) (V3)
					;Removes a task of the given name to address from the
					;patch TaskList
	EITEM PATT_TaskListType		;(BOOL) (G) (V3) Default: False
					;Get the type of the TaskList
	EITEM PATT_TaskList		;(BOOL) (G) (V3) Default: False
					;Return a taglist containing all TaskIDs and TaskNames attached
					;to a patch


	ENUM TAG_USER+$5000+30

	EITEM PATT_TimeOut		;(ULONG) (R) Default: NULL
					;The number of ticks (1/50 seconds) the function
					;should keep trying to remove the patch, if another
					;task is running in the patchcode.
	EITEM PATT_DelayedExpunge	;(BOOL) (R) Default: TRUE
					;If this tag is set to TRUE and a
					;non-patch.library patch was installed
					;after the patch.library patch for a
					;specific library function the specified
					;patch will nevertheless be removed.
					;BUT some resources will still be kept
					;allocated by patch.library (e.g.: the
					;Library Offset Vector will not be restored
					;to it's old state).
					;Patch.library will try to deallocate
					;those resources automatically, if the
					;system is getting low on memory or
					;if you call a patch.library function
					;that removes or installs patches.

;-------------------------------------------------------------------------
; types for PATT_CreateTaskList tag:
TL_TYPE_INCLUDE		= 1	;Type of TaskList is include 
				;(all specified tasks will use the patchroutine, all others will ignore it)
TL_TYPE_EXCLUDE		= 2	;Type of TaskList is exclude
				;(all specified tasks will ignore the patchroutine, all others will use it)


	ENDC	;LIBRARIES_PATCH_TAGS_I
